/* << High C V1.4 >> **********************************************************
**
**	CDtײؗpͯ
**
**	1991.02.09 : CREATE
**	1991.02.12 : FINISH
**
**	< HISTORY >
**	1991.02.09 : CREATE
**	1991.02.19 : SHUFFLE@\̒ǉ.
**	1991.02.27 : SʉJn....
**
**	< note > : TABS = 4
**
**	All Rights Reserved, Copyright (C) Y.Hirata 1991.
**
**	Programmed by Y.Hirata ( Nifty ID : NAB03321 )
**
******************************************************************************/

#undef	EX
#ifdef _CDDA_LIB						/*  ײؿp						*/
	#define	EX
	char	CDDA_DEBUG = 0 ;			/*	 DEBUG p 	*/
#else									/*  ײ؎gp					*/
	#define	EX		extern
	EX char	CDDA_DEBUG ;				/*	 DEBUG p 	*/
#endif

#define	CDDA_MAX_TRACK		99			/*  CD-ROM őׯ:99			*/
#define	CDDA_MIN_TRACK		1			/*  CD-ROM ŏׯ:1				*/
#define	CDDA_ZERO			0
#define	CDDA_TRUE			1			/*  ^l							*/
#define	CDDA_FALSE			0			/*  Ul							*/
#define	CDDA_ERROR			-1			/*  װݒl					*/
#define	CDDA_NOERROR		CDDA_ZERO	/*  Iݒl				*/
#define	CDDA_RETRY			5			/*  װײ				*/
#define	CDDA_MAX_REPEAT		255			/*  ő剉t߰ĉ				*/
#define	CDDA_MIN_REPEAT		1			/*  ŏt߰ĉ				*/
#define	CDDA_FFREV_SEC		1			/*  摗/߂莞Ēl[b]		*/

/*
**	ϸۂgp鑤ŁAstdio.h, stdlib.h, time.h  include ĉI
*/
#define	CDDA_RANDINIT		srand((unsigned int)clock())	/*  	*/
#define	CDDA_RANDOM(x)		(rand()%(x))					/*   : 0`x	*/


/*	CDߒl̒`	*/

#define	CDDA_TYPE_NO		0			/*  Ȃ							*/
#define	CDDA_TYPE_CDDA		1			/*  CD-DA							*/
#define	CDDA_TYPE_DATA		2			/*  DATA							*/
#define	CDDA_TYPE_BOTH		3			/*  CD-DA & DATA					*/


/*	l̒`	*/

#define	CDDA_SW_EXIT		-1			/*  tI						*/
#define	CDDA_SW_EJECT		-1			/*  tI						*/
#define	CDDA_SW_STOP		0			/*  t~						*/
#define	CDDA_SW_PAUSE		0x100		/*  tꎞ~					*/
#define	CDDA_SW_TOCREAD		0x101		/*  TOC Ǐo						*/
#define	CDDA_SW_PLAY		0x102		/*  tJn						*/
#define	CDDA_SW_SHUFFLE		0x104		/*  ىt						*/
#define	CDDA_SW_INIT		0x108		/*  						*/
#define	CDDA_SW_STATUS		0x110		/*  CDtԎ擾					*/
#define	CDDA_SW_PROGRAM		0x200		/*  ۸щt						*/
#define	CDDA_SW_CONTINUE	0x201		/*  AĐ						*/
#define	CDDA_SW_SINGLE		0x202		/*  ȉt						*/
#define	CDDA_SW_REPEAT		0x204		/*  ߰Đݒ						*/
#define	CDDA_SW_BREAK		0x400		/*  						*/
#define	CDDA_SW_FFMUSIC		0x401		/*  Ȑ摗(܂)		*/
#define	CDDA_SW_REWMUSIC	0x402		/*  Ȍ߂(܂)		*/
#define	CDDA_SW_FFTIME		0x404		/*  Ԑ摗(܂)		*/
#define	CDDA_SW_REWTIME		0x408		/*  Ԍ߂(܂)		*/
#define	CDDA_SW_PRG_CHECK	0x800		/*  ۸щtȂ̊mF				*/
#define	CDDA_SW_PRG_CLEAR	0x801		/*  ۸щtȂ̍폜				*/
#define	CDDA_SW_PRG_TOP		0x802		/*  ۸щtȂ̈ʒu߲ر		*/


/*	ðl̒`	*/

#define	CDDA_STAT_NOTREADY	-1			/*  NOT READY						*/
#define	CDDA_STAT_STOP		0			/*  ~							*/
#define	CDDA_STAT_PLAY		1			/*  t							*/
#define	CDDA_STAT_PAUSE		2			/*  ꎞ~						*/


/*	װl̒`		*/

#define	CDDA_ERR_NOERROR	CDDA_ZERO	/*  							*/
#define	CDDA_ERR_NOTREADY	0x001		/*  CDĂĂȂ				*/
#define	CDDA_ERR_PARAMETER	0x002		/*  װ						*/
#define	CDDA_ERR_NOTCONNECT	0x004		/*  ײނڑ					*/
#define	CDDA_ERR_ABNORMAL	0x008		/*  ނُI					*/
#define	CDDA_ERR_MEDIA		0x010		/*  ިװ						*/
#define	CDDA_ERR_HARD		0x020		/*  ʰ޴װ							*/
#define	CDDA_ERR_PARITY		0x040		/*  èװ						*/
#define	CDDA_ERR_CHANGE		0x080		/*  ި					*/
#define	CDDA_ERR_DEVICENO	0x100		/*  w޲ԍ				*/
#define	CDDA_ERR_SECTOR		0x101		/*  Ⴄ						*/
#define	CDDA_ERR_NOWPLAY	0x102		/*  yt						*/
#define	CDDA_ERR_NOWPAUSE	0x104		/*  yꎞ~				*/
#define	CDDA_ERR_NOTPAUSE	0x108		/*  ꎞ~ԂłȂ				*/
#define	CDDA_ERR_NOMUSIC	0x110		/*  yްȂ					*/
#define	CDDA_ERR_REPEAT		0x120		/*  ߰ĉtJn				*/


/*---------------------------------------------------------------------------*/
/*
**	ް\`
*/
/*---------------------------------------------------------------------------*/
typedef struct {						/*  CD-ROM ȏp					*/
		char	min ;							/*     ( 1min = 60sec )	*/
		char	sec ;							/*  b   ( 1sec = 75frame )	*/
		char	frame ;							/*  ڰ					*/
} CDDA_TRACK ;

typedef struct {						/*  CD-ROM 						*/
		int		drv ;							/*  CDײޔԍ(0`6)		*/
		int		type ;							/*  CD					*/
		int		start ;							/*  擪ׯ()ԍ		*/
		int		end ;							/*  ŏIׯ()ԍ		*/
		CDDA_TRACK	track[CDDA_MAX_TRACK] ;		/*  eׯ̉tJn	*/
		CDDA_TRACK	discend ;					/*  ިtI		*/
} CDDA_INFO ;


/*---------------------------------------------------------------------------*/
/*
**	۰ް
*/
/*---------------------------------------------------------------------------*/
EX CDDA_INFO	CDDA_INFO_buf ;						/*  CDi[p		*/

EX CDDA_TRACK	CDDA_CLOCK_nowdisc ;	/*  tިt			*/
EX CDDA_TRACK	CDDA_TIME_nowdisc ;		/*  tިc艉t		*/
EX CDDA_TRACK	CDDA_CLOCK_nowtrack ;	/*  tׯt			*/
EX CDDA_TRACK	CDDA_TIME_nowtrack ;	/*  tׯc艉t		*/
EX CDDA_TRACK	CDDA_CLOCK_program ;	/*  ۸їp߲Ă̍v	*/
EX CDDA_TRACK	CDDA_TIME_track[CDDA_MAX_TRACK] ;	/*  eׯ̉t	*/
EX CDDA_TRACK	CDDA_TIME_music ;					/*  Sׯ̉t	*/
EX CDDA_TRACK	CDDA_TIME_data ;					/*  Sް			*/
EX CDDA_TRACK	CDDA_TIME_program ;					/*  S۸ю		*/
EX CDDA_TRACK	CDDA_TIME_program2 ;				/*  ۸іI	*/
EX CDDA_TRACK	CDDA_CLOCK_start ;					/*  tJnw莞	*/
EX CDDA_TRACK	CDDA_CLOCK_end ;					/*  tIw莞	*/
EX CDDA_TRACK	CDDA_CLOCK_pause ;					/*  ꎞ~̎	*/

EX int		CDDA_NOW_status ;			/*  ݂CDt				*/
EX int		CDDA_NOW_musicno ;			/*  ݉t̋Ȕԍ				*/
EX int		CDDA_NOW_start ;			/*  tJnȔԍ					*/
EX int		CDDA_NOW_end ;				/*  tIȔԍ					*/
EX int		CDDA_NOW_pause ;			/*  ꎞ~̋Ȕԍ				*/

EX int		CDDA_TOTAL_program ;		/*  ۸ѓo^Ȑ					*/
EX int		CDDA_COUNT_program ;		/*  ۸ъmFȖ				*/
EX int		CDDA_REMAIN_program ;		/*  ۸юc艉tȐ				*/

/*---------------------------------------------------------------------------*/
/*
**	֐ߐ錾
*/
/*---------------------------------------------------------------------------*/

/*
**	CDDA.C
*/
void CDDA_music_clear( void ) ;
void CDDA_libinit( void ) ;
int CDDA_cdinfo( void ) ;
int CDDA_tocread( void ) ;
int CDDA_seek( void ) ;
int CDDA_mtrplay( void ) ;
void CDDA_stop( void ) ;
int CDDA_mphase( void ) ;
int CDDA_shuffle_check( void ) ;
void CDDA_program_playend( void ) ;
int CDDA_program_check( void ) ;
int CDDA_continue_check( int ) ;
int CDDA_single_check( int ) ;
int CDDA_play_check( void ) ;
void CDDA_nplay_check( void ) ;
int CDDA_get_status( void ) ;
int CDDA_status( void ) ;
int CDDA_timeplay( void ) ;
int CDDA_play( void ) ;
int CDDA_pause( void ) ;
void CDDA_shuffle_init( void ) ;
int CDDA_shuffle( int * ) ;
int CDDA_program_data_check( void ) ;
int CDDA_program_data_clear( void ) ;
int CDDA_program_data_add( int ) ;
int CDDA_swinit( void ) ;
void CDDA_select_stop( int ) ;
int CDDA_select_music( int ) ;
void CDDA_select_mode( int ) ;
int CDDA_select_play( void ) ;
int CDDA_select_shuffle( void ) ;
int CDDA_select_program( int ) ;
void CDDA_initstatus( void ) ;
int CDDA_switch( int ) ;
int CDDA_get_playmode( void ) ;
void CDDA_debug_dispmsg( int ) ;

/*
**	CDTIME.C
*/
int	CDDA_cmptime( signed char,signed char,signed char,signed char,signed char,signed char ) ;
void CDDA_subtime( char,char,char,char,char,char,char *,char *,char * ) ;
void CDDA_addtime( char,char,char,char,char,char,char *,char *,char * ) ;
void CDDA_set_time_start( int ) ;
void CDDA_set_time_end( int ) ;
void CDDA_timecalc( void ) ;
void CDDA_remaintime( void ) ;
void CDDA_program_remaintime( void ) ;
int CDDA_data_check( int ) ;
int CDDA_next_music( void ) ;
int CDDA_before_music( void ) ;
int CDDA_fftime( void ) ;
int CDDA_rewtime( void ) ;
int CDDA_ffmusic( void ) ;
int CDDA_rewmusic( void ) ;

#undef	EX
